	TITLE		"RECONECTADORA ELECTRNICA"
	LIST		P=16F870
	#INCLUDE	<P16F870.INC>
;	__config 0x3D18					;Nigel
	__CONFIG		0x373A          ;0011 0111 x011 1010
;------------------------------------------ VARIABLE DEFINITION

	CBLOCK 0x20
		B_EDO1								;CI/OI/ENC/ETMX/EDFX/ISRTMDF//EDFxU
		B_EDO2
		B_EDO3
		B_EDO4
		ADCH
		ADCL
		ADCLHN
		C_TM
		C_DF
		d1
		d2
		set_old
		set_dec
		set_cmp
		m_30
		m_31
		m_32
		t_1
		t_2
		t_3
		W_temp
		S_temp
	ENDC

;------------------------------------------ ORIGINS

	ORG		0x00
	goto	MAIN

	ORG		0x04
	goto	ISR

	ORG 	0x05
;------------------------------------------ MAIN
MAIN
	call	CFG_OPTION
	call	CFG_INTCON
	call	CFG_PORTS

	bcf		STATUS,	RP0
	bsf		PORTA,	1						;LED ON, system ON
	
	call 	INI_VARIABLES
	goto	CHK_SYSTEM

LOOP
	goto	TEMPORIZADOR

ADC_R
	btfsc	B_EDO4,	5						;ADC_ready flag (5)
	goto	ADC
A_M
	btfss	PORTB,	4						;Autommatic (1) /Manual (0)	
	goto 	MANUAL

LOOP1
	btfsc	B_EDO4,	0						;RESTORE C_TM & C_DF
	goto 	MANUAL

CHK_CI
	btfsc	B_EDO1,	7						;CLOSE interruptor?
	goto 	O_C_I

CHK_OI
	btfsc	B_EDO1,	6						;OPEN interruptor?
	goto 	O_C_I

DFExU
	btfsc	B_EDO1,	0						;TMExUser ?
	goto	EDFU

	btfss	PORTB,	1						;TM event?
	goto	TM_event

	btfsc	B_EDO1,	3						;DFx event?
	goto 	DF_event

;------------------------------------------ Signal Acquisition by ADC on PORTA, 0
ADC
	bsf		ADCON0,	GO_DONE
	btfsc	ADCON0,	GO_DONE
	goto 	$-1								;Wait ADC to finish
	
	movf	ADRESH,	W
	andlw	0x03
	movwf	ADCH

	bsf		STATUS,	RP0
	movf	ADRESL,	0
	bcf		STATUS,	RP0
	movwf	ADCL

;	btfsc	B_EDO4,	5						;ADC_ready flag, then check values
	goto	CHK_ADC_VALUES

;------------------------------------------ Timer Defined by User (event persistance)
TEMPORIZADOR
	movf	B_EDO2,	W
	andlw	0xE0
	movwf	B_EDO2

	btfss	PORTB,	7
	goto	CHK1
	btfss	PORTB,	6
	goto	CHK2
	btfss	PORTB,	5
	goto 	CHK3
	
	movlw	0x01
	bsf		B_EDO2,	0						;position 0 for 20 ms
	goto	TEMPO_READY

CHK1
	btfss	PORTB,	6
	goto 	NV_E
	btfss	PORTB,	5
	goto 	NV_E

	movlw	0x32
	bsf		B_EDO2,	4						;position 4 for 1000 ms
	goto	TEMPO_READY

CHK2
	btfss	B_EDO2,	5
	goto 	CHK4

	movlw	0x0F
	bsf		B_EDO2,	2						;position 2 for 300 ms
	goto	TEMPO_READY

CHK3
	movlw	0x05
	bsf		B_EDO2,	1						;position 1 for 100 ms
	goto	TEMPO_READY

CHK4
	movlw	0x19
	bsf		B_EDO2,	3						;position 3 for 500 ms

TEMPO_READY
	btfsc	B_EDO4,	1						;1st cycle
	goto	CYCLE_DONE
	bsf		B_EDO4,	1						;set 1st cycle flag

SET_VARIABLES
	movwf	set_old
	movwf	set_dec
	movwf	set_cmp
	goto 	CHK_sensibility

CYCLE_DONE
	bcf		STATUS,	Z
	xorwf	set_cmp, F
	btfss	STATUS,	Z
	goto	SET_VARIABLES

;	goto	CHK_sensibility		;SE PUEDE OMITIR

;------------------------------------------ SENSIBILITY
CHK_sensibility
	movlw	0xF8
	andwf	B_EDO3,	f

	btfss	PORTB,	3						;Sensibility defined by USER
	goto	mA600
	btfss	PORTB,	2
	goto	mA300

	bsf		B_EDO3,	0						;30mA
	goto	ADC_R		;CHK_ADC_VALUES

mA600
	btfss	PORTB,	2
	goto	NV_E
	bsf		B_EDO3,	2						;300mA
	goto	ADC_R		;CHK_ADC_VALUES

mA300
	bsf		B_EDO3,	1						;600mA

	goto	ADC_R
;------------------------------------------ Compare ADC values Vs Defined by user
CHK_ADC_VALUES
	btfsc	B_EDO3,	0						;30mA ?
	goto	mA30_ADC
	btfsc	B_EDO3,	1						;300mA
	goto	mA300_ADC
	goto	mA600_ADC

mA30_ADC
	movf	ADCH,	w
	bcf		STATUS,	Z
	xorlw	0x00
	btfss	STATUS,	Z
	goto	DF_event

CHK_ADCL
	movf	ADCL,	W
	andlw	0xF0
	movwf	ADCLHN
	movf	ADCLHN,	W
	bcf		STATUS,	Z
	xorlw	0xF0
	btfss	STATUS,	Z
	goto	NO_EDF2
	bsf		B_EDO3,	3						;EDF1 flag
	goto	DF_event
	
mA300_ADC
	movf	ADCH,	W
	bcf		STATUS,	Z
	xorlw	0x00
	btfsc	STATUS,	Z
	goto	NO_EDF2
	movf	ADCH,	W
	bcf		STATUS,	Z
	xorlw	0x01
	btfsc	STATUS,	Z
	goto	CHK_ADCL
	goto	DF_event

mA600_ADC
	movf	ADCH,	W
	bcf		STATUS,	Z
	xorlw	0x00
	btfsc	STATUS,	Z
	goto 	NO_EDF2

	movf	ADCH,	W
	bcf		STATUS,	Z
	sublw	0x01
	btfsc	STATUS,	Z
	goto 	NO_EDF2

	bcf		STATUS,	Z
	sublw	0x02
	btfsc	STATUS,	Z
	goto 	CHK_ADCL
	bsf		B_EDO3,	3						;EDF1 flag
	goto	DF_event

NO_EDF2
	btfss	B_EDO3,	4						;EDF2 ? & no EDF1
	goto 	LOOP							;NO
	bcf		B_EDO3,	4						
	bcf		B_EDO3,	5						;EDF_waiting, 0
	bcf		B_EDO4,	5						;ADC_ready, 0
	goto 	ADC_R

;------------------------------------------ DF event by USER
EDFU
	incf	C_DF,	F
	goto	CHK_EDFU						;Go to check if enclave or set 
EDFU_back
	bsf		PORTA,	3						;DF LED on

	movlw	0x48
	movwf	B_EDO1							;CI=0;OI=1;EDFX=1;ISRTMDF;ETMX
											;EDFxU=0
	bcf		INTCON,	INTE					;Stop RB0/INT

	movlw	0x07
	andwf	B_EDO3						;EDF1=0;EDF2=0;EDF_waiting=0
											;restore 30 minutes;stop 30 minute

;	bsf		B_EDO1,	3						;EDFX

	goto	O_C_I							;go to open

;------------------------------------------ TM event has occured
TM_event
	bcf		B_EDO3,	5						;DFE_waiting flag cleared, 
	btfsc	B_EDO1,	3						;EDFX is 0
	goto	ADC_R
	btfsc	B_EDO1,	4						;ETMX?
	goto	CHK_CI

	bsf		PORTA,	2						;TM LED on
	bcf		INTCON,	INTE					;STOP RB0

	incf	C_TM,	F
	btfss	C_TM,	0						;first event ?
	goto	$+4
	btfss	C_TM,	1						;second event ?
	goto	$+2
	goto	NV_E							;third event

	movlw	0x07							;0000 0,600,300,30
	andwf	B_EDO3							;B_EDO3

	movlw	0x50							;OI,ETMX
	movwf	B_EDO1							;B_EDO1

	goto 	CHK_OI

;------------------------------------------ DF event has occured
DF_event
	btfsc	B_EDO3,	0						;30mA
	goto	EDFU
	btfsc	B_EDO3,	1
	goto	E_300_600mA

INC_300_600
	incf	C_DF,	F
CHK_EDFU
	movf	C_DF,	W
	bcf		STATUS,	Z
	xorlw	0x1F
	btfsc	STATUS,	Z
	goto 	NV_E

	btfss	B_EDO2, 7						;DF3
	goto	$+4
	btfsc	B_EDO1,	0						;EDFxU
	goto	EDFU
	goto	EDF2_set						;2nd DF event occurred

	movlw	0x01
	bcf		STATUS,	Z
	xorwf	C_DF,	W
	btfss	STATUS,	Z
	goto	DF2_set
	bsf		B_EDO2,	5						;DF1

see_back
	btfsc	B_EDO3,	0						;30mA?
	goto	EDFU_back						;yes, return to EDFU
	btfsc	B_EDO1,	0						;EDFxU?
	goto	EDFU_back						;yes, return to EDFU
	goto	EDF2_set						;2nd DF event occurred

DF2_set
	movlw	0x02
	bcf		STATUS,	Z
	xorwf	C_DF,	W
	btfss	STATUS,	Z
	goto	DF3_set
	bcf		B_EDO2,	5
	bsf		B_EDO2,	6						;DF2
	goto	see_back

DF3_set
	bcf		B_EDO2,	6
	bsf		B_EDO2,	7						;DF3
	goto	see_back

;------------------------------------------ Posssible Events: 300 or 600 mA
E_300_600mA
	btfsc	B_EDO3,	5						;EDF_waiting
	goto	$+2
	bsf		B_EDO3,	5						;EDF_waiting SET

	btfss	B_EDO3,	4
	goto	NO_FUE
	goto	INC_300_600

EDF2_set
	bsf		PORTA,	3						;DF LED ON

	movlw	0x07
	andwf	B_EDO3,	F
	bcf		B_EDO4,	5						;ADC_ready
	bcf		INTCON,	INTE					;RB0/INT off
	movlw	0x48
	movwf	B_EDO1
	goto	O_C_I

NO_FUE
	bsf		B_EDO3,	5						;EDF_waiting SET
	bcf		B_EDO3,	3						;EDF1 = 0
	goto 	LOOP

;------------------------------------------ OPEN/CLOSE INTERRUPTOR
O_C_I
	btfsc	B_EDO1,	5						;Enclave
	goto	OPEN
	btfsc	B_EDO1,	7						;Close interrupt
	goto 	CLOSE
	goto 	OPEN

CLOSE										;Close to open = TM event
	bsf		PORTA,	5						;CLOSE CONTROL BIT
	goto 	DELAY_50i

OPEN
	btfss	PORTB,	1
	goto	CHK_OI
	bsf		PORTA,	4						;OPEN CONTROL BIT

DELAY_50i
	movlw	0x0E
	movwf	d1
	movlw	0x28
	movwf	d2

DELAY_50
	decfsz	d1,		F						;F=1
	goto	$+2
	decfsz	d2,		1
	goto	DELAY_50
;	goto	$+1

	btfsc	B_EDO1,	7						;CI flag ?
	goto	END_CLOSE

	bcf		PORTA,	4						;turn off, OPEN CONTROL bit
	bsf		B_EDO1,	6						;turn on, open interruptor flag
	bcf		B_EDO3,	3						;EDF1 = 0
	bcf		B_EDO3, 4						;EDF2 = 0
	bcf		INTCON,	INTE					;No RB0/INT

	btfsc	B_EDO1,	5						;enclave?
	goto	NV_E1

	goto 	LOOP

END_CLOSE
	bcf		PORTA,	2						;TM LED off
	bcf		PORTA,	3						;DF LED off
	bcf		PORTA,	5						;turn off, CLOSE CONTROL bit, relay
											
	movlw	0x00							;B_EDO1: 0000 0000
	movwf	B_EDO1						;CI,=I,ENC,ETMX,EDFX,ISRTMDF,x,EDFxU

	bsf		INTCON,	INTE					;turn on, RB0/INT interrupt

	movlw	0x00							;TM events have occurred
	bcf		STATUS,	Z						;if not, no 30min countdown
	xorwf	C_TM,	W
	btfss	STATUS,	Z
	goto	INI_CD							;antes DFExU

	movlw	0x00
	bcf		STATUS,	Z
	xorwf	C_DF,	W
	btfsc	STATUS,	Z
	goto 	LOOP
INI_CD
	bsf		B_EDO3,	7						;start 30 minute
	bcf		B_EDO3,	6						;restore 30 minutes
	goto 	LOOP							

;------------------------------------------ Interrupt Service Routine T0&RB0
ISR
;	movlw	0x00
;	bcf		STATUS,	Z
;	xorwf	TMR0
;	btfsc	STATUS,	Z
;	goto	$+3


	movwf	W_temp							;save W	in W_temp
	swapf	STATUS,	W						;move STATUS to W
	movwf	S_temp							;save STATUS in S_temp

	btfsc	INTCON,	INTF					;DF Event Generated by user ?
	goto 	EDFxU							;yes

	movlw	0xB1
	movwf	TMR0

	btfsc	B_EDO3,	5						;waiting for a 2nd DF event ?
	goto	DELAY_tempo

	btfsc	B_EDO1,	4						;EMTX ? is set
	goto	REC_TMDF						;yes

TMDF
	btfsc	B_EDO1,	3						;EDFX ? is set
	goto	REC_TMDF						;yes

;------------------------------------------ Count Down 30 minutes
m30
	btfss	B_EDO3,	7						;CD30, count down
	goto	END_TO

m30_set
	btfsc	B_EDO3,	6						;30! ?
	goto	DELAY_30
	movlw	0x64							;100
	movwf	m_30
	movlw	0x14
	movwf	m_31
	movlw	0x2D
	movwf	m_32

DELAY_30
	decfsz	m_30,	F
	goto	FIX_CD
	decfsz	m_31,	F
	goto	RELOAD_30
	decfsz	m_32,	F
	goto	RELOAD_30_31
	bsf		B_EDO4,	0						;RestoreC_TM_DF
	goto	END_TO

FIX_CD
	btfsc	B_EDO4,	6						;30!
	goto	END_TO
	bsf		B_EDO4,	6						;30! set
	goto	END_TO

RELOAD_30
	movlw	0x64
	movwf	m_30

RELOAD_30_31
	movlw	0x64
	movwf	m_30
	movlw	0x0A
	movwf	m_31
	goto	END_TO

;------------------------------------------ Evento TM & DF
REC_TMDF
	btfsc	B_EDO1,	2;						;IRSTMDF
	goto	DELAY_event

	movlw	0x64							;100
	movwf	t_1

	btfsc	B_EDO2,	6						;DF2 ?
	goto	seg40

	btfsc	B_EDO2,	4						;ETMX ?
	goto	min1

seg20
	movlw	0x0A							;10
	movwf	t_2

	btfsc	B_EDO2,	5						;DF1
	goto	DELAY_event

min5
	movlw	0x0F
	movwf	t_3

seg40
	movlw	0x14							;20
	movwf	t_2
	goto 	DELAY_event

min1
	movlw	0x19							;25
	movwf	t_2

DELAY_event
	decfsz	t_1,	F
	goto	FIX_ISRTMDF
	decfsz	t_2,	F
	goto	LOAD_t1
	goto	CHK_timing

TIME_3
	decfsz	t_3,	F
	goto	END_TO

END_delay
	movlw	0x8C
	addwf	B_EDO1
	goto	m30

FIX_ISRTMDF
	btfsc	B_EDO1,	2						;ISRTMDF ?
	goto	END_TO							;ISRTMDF already set
	bsf		B_EDO1,	2						;ISRTMDF set
	goto	END_TO

LOAD_t1
	movlw	0x64;							;100
	movwf	t_1
	goto	END_TO

CHK_timing
	btfsc	B_EDO1,	4						;ETMX	?
	goto	END_delay
	btfss	B_EDO3, 7						;DF3 ?
	goto	END_delay
	movlw	0x64							;100
	movwf	t_1
	movlw	0x0A							;10
	movwf	t_2
	goto	TIME_3

;------------------------------------------ Waiting for a 2nd DF event
DELAY_tempo
	decfsz	set_dec,	F
	goto	TMDF
											;Delay finished
	movf	set_old,	W
	movwf	set_dec
	movwf	set_cmp
	bsf		B_EDO3,	4						;EDF2 set
	bsf		B_EDO4,	5						;ADC_ready set
	goto	END_TO

;------------------------------------------ DF event by user, generated by RB0
EDFxU
	bsf		B_EDO1,	0						;EDFxU
	bcf		INTCON,	INTF
	goto	END_ISR

END_TO
	bcf		INTCON,	T0IF
END_ISR
	swapf	S_temp,	W						;Restore STATUS
	movwf	STATUS
	swapf	W_temp,	F						
	swapf	W_temp,	W						;Restore W without  affecting status
	RETFIE

;------------------------------------------ No counters available
MANUAL
	bcf		B_EDO4,	0						;Restore, set when 30min finished
	bcf		B_EDO3,	7						;stop 30 minutes
	bcf		B_EDO3,	6						;restore 30 minutes
	bcf		B_EDO1,	2						;ISRTMDF to 0
	clrf	C_TM
	clrf	C_DF
	goto	LOOP1

;------------------------------------------ ENCLAVE & NO VALID routine
NV_E
	bcf		INTCON,	T0IE
	bcf		INTCON,	INTE
	bsf		PORTA,	2					;TM LED on
	bsf		PORTA,	3					;DF LED on
	bsf		B_EDO1,	5					;ENCLAVE flag on
NV_E1
	btfss	PORTB,	1
	goto 	$-1
	goto	O_C_I

;------------------------------------------ CLOSE Interruptor if initially opened
CHK_SYSTEM
	btfsc	PORTB,	1
	goto 	LOOP
	bsf		B_EDO1,	7						;Close interrupt
	goto	O_C_I

;------------------------------------------ OPTION_REG
CFG_OPTION
	bsf		STATUS,	RP0						;Bank 1
	bcf		STATUS, RP1

	bcf		OPTION_REG,	INTEDG				;interrupt on falling adge
	bcf		OPTION_REG,	T0CS				;internal instruction cycle clock
	bcf		OPTION_REG,	PSA					;prescaler is assigned to T0
;	bsf		OPTION_REG,	PS2					; Prescaler rate
;	bsf		OPTION_REG,	PS1					; 1:256 TMR0 rate
;	bsf		OPTION_REG,	PS0

	RETURN
;------------------------------------------ INTCON
CFG_INTCON
	bcf		STATUS,		RP0					;Bank 0

	movlw	0xB1							;every 20ms
	movwf	TMR0

	bsf		INTCON,		GIE					;Global enable bit (7)
	bsf		INTCON,		T0IE				;Enable TMR0 interrupt (5)
	bsf		INTCON,		INTE				;Enable RB0/INT external interrupt (4)

;	bcf		INTCON,		T0IF				;Timer flag to 0
;	bcf		INTCON,		INTF				;Interrupt RB0 to 0

	RETURN

;------------------------------------------ PORTS
CFG_PORTS
;	bcf		STATUS, RP0
;------------------------------------------ PORT A
	clrf	PORTA

	movlw	0x41							;<5MHz/AN0/start/x/ADON
	movwf	ADCON0							;01 000	0	x 1

	bsf		STATUS, RP0

	movlw	0xFE							;RJ/x/(0 analog)-(1:5 digital)
	movwf	ADCON1							;1 xxx 1110

	movlw	0x01							;(0 analog=input)-(1:5 digital=output)
	movwf	TRISA

;	clrf	PORTB
;	clrf	PORTC
;------------------------------------------ PORT B & C
;	movlw	0xFF
;	movwf 	PORTB
;	movwf 	PORTC

	RETURN

;------------------------------------------ Variables initialization
INI_VARIABLES
	movlw 	0x20 							;initialize pointer
	movwf 	FSR 							;to RAM
NEXT
	clrf 	INDF 							;clear INDF register
	incf 	FSR,F 							;inc pointer
	bcf		STATUS,	Z
	movf	FSR,	W
	xorlw	0x36							;S_temp
	btfss 	STATUS,	Z 							;all done?
	goto 	NEXT 							;no clear next

;	movlw	0x00
;	movwf	B_EDO1
;	movwf	B_EDO2
;	movwf	B_EDO3
;	movwf	B_EDO3
;	movwf	ADCH
;	movwf	ADCL
;	movwf	ADCLHN
;	movwf	C_TM	
;	movwf	C_DF

;	movwf	set_old
;	movwf	set_dec
;	movwf	set_cmp
;	movwf	m_30
;	movwf	m_31
;	movwf	m_32
;	movwf	t_1
;	movwf	t_2
;	movwf	t_3
;	movwf	W_temp
;	movwf	S_temp

	RETURN

	END
